#jinja2: lstrip_blocks: True
# netdata configuration for aggregating data from remote hosts
#
# API keys authorize a pair of sending-receiving netdata servers.
# Once their communication is authorized, they can exchange metrics for any
# number of hosts.
#
# You can generate API keys, with the linux command: uuidgen


# -----------------------------------------------------------------------------
# 1. ON SLAVE NETDATA - THE ONE THAT WILL BE SENDING METRICS

[stream]
    # Enable this on slaves, to have them send metrics.
    enabled = {{ netdata_stream_client_enabled }}

    {% if netdata_stream_client_enabled %}
    # Where is the receiving netdata?
    # A space separated list of:
    #
    #      [PROTOCOL:]HOST[%INTERFACE][:PORT]
    #
    # If many are given, the first available will get the metrics.
    #
    # PROTOCOL  = tcp, udp, or unix (only tcp and unix are supported by masters)
    # HOST      = an IPv4, IPv6 IP, or a hostname, or a unix domain socket path.
    #             IPv6 IPs should be given with brackets [ip:address]
    # INTERFACE = the network interface to use (only for IPv6)
    # PORT      = the port number or service name (/etc/services)
    #
    # This communication is not HTTP (it cannot be proxied by web proxies).
    destination = {{ netdata_stream_destination|join(' ') }}

    # The API_KEY to use (as the sender)
    api key = {{ netdata_stream_api_key }}

    # The timeout to connect and send metrics
    timeout seconds = {{ netdata_stream_timeout }}

    # If the destination line above does not specify a port, use this
    default port = {{ netdata_stream_destination_port }}

    # The buffer to use for sending metrics.
    # 1MB is good for 10-20 seconds of data, so increase this
    # if you expect latencies.
    buffer size bytes = {{ netdata_stream_buffer_size }}

    # If the connection fails, or it disconnects,
    # retry after that many seconds.
    reconnect delay seconds = {{ netdata_stream_reconnect_delay_seconds }}

    # Attempt to sync the clock the of the master with the clock of the
    # slave for that many iterations, when starting.
    initial clock resync iterations = {{ netdata_stream_initial_clock_resync }}

{% endif %}
{% if netdata_stream_server_enabled %}
# -----------------------------------------------------------------------------
# 2. ON MASTER NETDATA - THE ONE THAT WILL BE RECEIVING METRICS

#    You can have one API key per slave,
#         or the same API key for all slaves.
#
#    netdata searches for options in this order:
#
#    a) master netdata settings (netdata.conf)
#    b) [API_KEY] section       (below, settings for the API key)
#    c) [MACHINE_GUID] section  (below, settings for each machine)
#
#    You can combine the above (the more specific setting will be used).

# API key authentication
# If the key is not listed here, it will not be able to push metrics.

# [API_KEY] is [YOUR-API-KEY], i.e [11111111-2222-3333-4444-555555555555]
{% for api_key,values in netdata_stream_server_config.iteritems() %}
[{{ api_key }}]
    # Default settings for this API key

    # You can disable the API key, by setting this to: no
    # The default (for unknown API keys) is: no
    enabled = {{ 'yes' if values['enabled']|default(netdata_stream_default_enabled) else 'no' }}

    # A list of simple patterns matching the IPs of the servers that
    # will be pushing metrics using this API key.
    # The metrics are received via the API port, so the same IPs
    # should also be matched at netdata.conf [web].allow connections from
    allow from = {{ values['allow_from']|default(netdata_stream_default_allow_from) }}

    # The default history in entries, for all hosts using this API key.
    # You can also set it per host below.
    # If you don't set it here, the history size of the central netdata
    # will be used.
    default history = {{ values['default_history']|default(netdata_stream_default_history) }}

    # The default memory mode to be used for all hosts using this API key.
    # You can also set it per host below.
    # If you don't set it here, the memory mode of netdata.conf will be used.
    # Valid modes:
    #    save    save on exit, load on start
    #    map     like swap (continuously syncing to disks)
    #    ram     keep it in RAM, don't touch the disk
    #    none    no database at all (use this on headless proxies)
    default memory mode = {{ values['default_memory_mode']|default(netdata_stream_default_memory_mode) }}

    # Shall we enable health monitoring for the hosts using this API key?
    # 3 possible values:
    #    yes     enable alarms
    #    no      do not enable alarms
    #    auto    enable alarms, only when the sending netdata is connected
    # You can also set it per host, below.
    # The default is the same as to netdata.conf
    health enabled by default = {{ values['default_health_enabled']|default(netdata_stream_default_health_enabled) }}

    # postpone alarms for a short period after the sender is connected
    default postpone alarms on connect seconds = {{ values['default_postpone_alarms']|default(netdata_stream_default_postpone_alarms) }}

    # need to route metrics differently? set these.
    # the defaults are the ones at the [stream] section
    {% if values['default_proxy_enabled']|default(netdata_stream_default_proxy_enabled) and values['default_proxy_destination']|default(netdata_stream_default_proxy_destination) %}
    default proxy enabled = yes
    default proxy destination = {{ values['default_proxy_destination']|default(netdata_stream_default_proxy_destination)|join(' ')}}
    default proxy api key = {{ values['default_proxy_api_key']|default(netdata_stream_default_proxy_api_key)|default('UNSET-UNSET-UNSET') }}
    {% else %}
    # default proxy enabled = yes
    # default proxy destination = {{ netdata_stream_default_proxy_destination|join(' ')}}
    # default proxy api key = {{ netdata_stream_default_proxy_api_key|default('') }}
    {% endif %}
{% endfor %}

# -----------------------------------------------------------------------------
# 3. PER SENDING HOST SETTINGS, ON MASTER NETDATA
#    THIS IS OPTIONAL - YOU DON'T NEED IT

# This section exists to give you finer control of the master settings for each
# slave host, when the same API key is used by many netdata slaves / proxies.
#
# Each netdata has a unique GUID - generated the first time netdata starts.
# You can find it at /var/lib/netdata/registry/netdata.public.unique.id
# (at the slave).
#
# The host sending data will have one. If the host is not ephemeral,
# you can give settings for each sending host here.

[MACHINE_GUID]
    # enable this host: yes | no
    # When disabled, the master will not receive metrics for this host.
    # THIS IS NOT A SECURITY MECHANISM - AN ATTACKER CAN SET ANY OTHER GUID.
    # Use only the API key for security.
    enabled = no

    # A list of simple patterns matching the IPs of the servers that
    # will be pushing metrics using this MACHINE GUID.
    # The metrics are received via the API port, so the same IPs
    # should also be matched at netdata.conf [web].allow connections from
    # and at stream.conf [API_KEY].allow from
    allow from = *

    # The number of entries in the database
    history = 3600

    # The memory mode of the database: save | map | ram | none
    memory mode = save

    # Health / alarms control: yes | no | auto
    health enabled = yes

    # postpone alarms when the sender connects
    postpone alarms on connect seconds = 60

    # need to route metrics differently?
    #proxy enabled = yes | no
    #proxy destination = IP:PORT IP:PORT ...
    #proxy api key = API_KEY
{% endif %}
